*+
*+
*+    Source Module => D:\SRC\POS\ERROR52.PRG
*+
*+    InOrder -=- Point of Sale
*+                Order Entry
*+                Inventory Control
*+                Purchasing
*+                Receiving
*+                Accounts Receivable
*+                EDI
*+    
*+    Copyright (C) 1986-1997, Phil Barnett. All Rights Reserved Worldwide.
*+    
*+    Programming Staff: Phil Barnett, Mark DeVuyst
*+
*+    Functions: Procedure ERRORSYS()
*+               Static Function DEFERROR()
*+               Static Function ERRORMESSAGE()
*+               Static Function DOSERRTEXT()
*+               Static Function ERR_OPEN_LIST()
*+               Static Function SEP_LINE()
*+               Static Function SYSTEMTXT()
*+               Static Function ERRORTXT()
*+               Static Function SCANCONV()
*+
*+       Tables: use DOS_ERR NEW
*+               use Scancode NEW
*+
*+      Indexes: index on DOS_ERR->ERR_NO to DOS_ERR
*+               index on SCANCODE->SCANCODE to Scancode
*+
*+    Reformatted by Click! 1.13b4 on Sep-1-1998 at  2:34 am
*+
*+


// #include "sixcdx.ch"
#include "ERROR.CH"
#include "COMMON.CH"

// PUT MESSAGES to STDERR
#command ? < list, ... > = > ?? chr( 13 ) + chr( 10 ) ; ?? < list >
#command ?? < list, ... > = > outerr( < list > )

// USED BELOW
#DEFINE NTRIM( N ) ( ltrim( str( N ) ) )
static CRLF         := chr( 13 ) + chr( 10 )
static TIMES_CALLED := 0

*+
*+
*+    Procedure ERRORSYS()
*+
*+
*+
proc ERRORSYS()

errorblock( { | E | DEFERROR( e ) } )
return

*+
*+
*+    Static Function DEFERROR()
*+
*+    Called from ( error52.prg  )   1 - procedure errorsys()
*+
*+
*+
static func DEFERROR( e )

local i
local AOPTIONS
local MSG         := {}
local FILETXT
local SCRNTXT
local DATEOUT
local Handle
local EXIT_MSG
local x
local SYSTXT
local CHOICE
local DESTINATION
local SPLITAT
local ERRMSG
local DOTHEBREAK
local thealias
local adefault

// BY default, DIVISION BY ZERO YIELDS ZERO
if ( e:GENCODE == EG_ZERODIV )
   return ( 0 )
endif

// for NETWORK OPEN error, set NETERR() and SUBSYSTEM default
if ( e:GENCODE == EG_OPEN .and. e:OSCODE == 32 .and. e:CANDEFAULT )

   neterr( .t. )
   return ( .f. )   // NOTE

endif

// for lock error DURING append blnk, set NETERR() and SUBSYSTEM default
if ( e:GENCODE == EG_APPENDLOCK .and. e:CANDEFAULT )

   neterr( .t. )
   return ( .f. )   // NOTE

endif

// POP error message and PROGRAM STACK IN A display BOX

dispend()           // MAKE SURE THE display IS on

#ifdef AXS
if e:SUBSYSTEM() + ( "/" + NTRIM( e:SUBCODE ) ) $ 'DBFCDXAX/6060'
   pop_msg( 'Advantage Database Server is not found' )
   quit
endif
#endif

if 'Print error' $ ERRORMESSAGE( e )
   CHOICE := MVERIFY( { 'Your Printer has an Error, and now you can:', ;
                        '', ;
                        '1. Fix what stopped the printer and Retry', ;
                        '2. Redirect the printer output to a file ', ;
                        '3. Give up and end the program           ' }, ;
                        1, { 'Retry', 'File', 'Abort' } )
   do case
   case CHOICE == 1
      return ( .t. )
   case CHOICE == 2
      DESTINATION := ASK_FOR( 'Enter a destination file name', space( 60 ), '@!' )
      set printer to ( DESTINATION )
      return ( .t. )
   endcase
   EXIT_MSG := 'User Aborted from Printer Error.'
else

   if ++ TIMES_CALLED > 2
      close all
      myshowtime()
      ALLKEY( 1 )
      setcursor( 1 )
      cls()
      errorlevel( 1 )
      quit
   endif

   SCRNTXT := SEP_LINE( 'Video Display' )
   for x := 0 to maxrow()
      SCRNTXT += CHARODD( savescreen( x, 0, x, maxcol() ) ) + CRLF
   next
   SCRNTXT += CRLF

   FILETXT := SEP_LINE( 'Open File Areas' ) + ERR_OPEN_LIST()

   SYSTXT := SEP_LINE( 'System Data' ) + SYSTEMTXT()

   if ( !empty( e:OSCODE ) )
      aadd( MSG, " (DOS Error " + NTRIM( e:OSCODE ) + ") " )
      aadd( MSG, DOSERRTEXT( e:OSCODE ) )
   else
      ERRMSG := ERRORMESSAGE( e )
      if len( ERRMSG ) > 70
         SPLITAT := at( ':', ERRMSG )
         aadd( MSG, left( ERRMSG, SPLITAT ) )
         aadd( MSG, substr( ERRMSG, SPLITAT + 1 ) )
      else
         aadd( MSG, ERRMSG )
      endif
   endif
   aadd( MSG, '' )

   i := 2
   do while ( !empty( procname( i ) ) )
      if !alltrim( procname( i ) ) $ 'LOCKERRHAN|(b)INITHANDL$'
         aadd( MSG, RJ( procname( i ), 10 ) + " Line # " + LJ( str( procline( i ) ), 5 ) )
      endif
      i ++
   enddo

   // WRITE error to file HERE

   // mrdump( ROOTNAME( EXENAME() ) + '.dmp' )

   if !file( ROOTNAME( EXENAME() ) + '.err' )
      Handle := fcreate( ROOTNAME( EXENAME() ) + '.err' )
      fwrite( Handle, replicate( chr( 219 ), 79 ) + CRLF )
   else
      Handle := fopen( ROOTNAME( EXENAME() ) + '.err', 2 )
   endif

   DATEOUT := '  ' + FULLDATE() + "    " + AM_PM() + '  '

   fseek( Handle, - ( 41 + ( len( DATEOUT ) / 2 ) ), 2 )

   fwrite( Handle, DATEOUT )

   fseek( Handle, 0, 2 )

   fwrite( Handle, CRLF + SEP_LINE( 'Function Call Stack' ) )

   i := 2
   do while !empty( procname( i ) )
      if !alltrim( procname( i ) ) $ 'LOCKERRHAN(b)INITHANDL$'
         fwrite( Handle, RJ( procname( i ), 15 ) + " Line # " + LJ( str( procline( i ) ), 5 ) + '  ' + str( i, 2 ) + CRLF )
      endif
      i ++
   enddo
   fwrite( Handle, CRLF )

   DOTHEBREAK := .f.
   if ischar( e:SUBSYSTEM() ) .and. e:SUBSYSTEM() + ( "/" + NTRIM( e:SUBCODE ) ) $ 'COMIX/1012|COMIX/8009'

      POP_MSG( { 'InOrder has detected a damaged index file.', ;
                 '', ;
                 'In an attempt to rebuild the index, it', ;
                 'will be necessary to close all files', ;
                 '', ;
                 'Even though every attempt is made to save', ;
                 'current data, it is possible that data may be lost.', ;
                 '', ;
                 'If possible, you will be returned to the', ;
                 'MAIN MENU after the index is repaired' } )

      THEALIAS := alias()

      D_CLOSE_ALL()

      kill_em( THEALIAS + myordbagext() )

      fwrite( Handle, SEP_LINE( 'Automatic Index Rebuild' ) )

      if reindex( THEALIAS )
         DOTHEBREAK := .t.
         fwrite( Handle, 'Rebuild of indexes for ' + THEALIAS + ' was successful' + CRLF + CRLF )
      else
         fwrite( Handle, 'Failed due to unknown alias' + CRLF + CRLF )
      endif

   endif

   fwrite( Handle, SEP_LINE( 'Error Object' ) + ERRORTXT( e ) + CRLF )

   fwrite( Handle, SEP_LINE( 'Previous Keystrokes' ) + SCANCONV( KEYREAD() ) + CRLF )

   fwrite( Handle, FILETXT )

   fwrite( Handle, SYSTXT )

   fwrite( Handle, SCRNTXT )

   fwrite( Handle, replicate( chr( 219 ), 79 ) + CRLF )

   fclose( Handle )

   if DOTHEBREAK
      break
   endif

   AOPTIONS := { "Quit" }

   if ( e:CANRETRY )
      aadd( AOPTIONS, "Retry" )
   endif

   // ONLY RETRY WHEN RUNNING TEST_DBV
   if ( e:CANDEFAULT ) .and. alltrim( procname( 3 ) ) == 'TEST_DBV'
      aadd( AOPTIONS, "Default" )
      ADEFAULT := len( AOPTIONS )
      // IF THIS IS FROM TEST_DBV, AUTOMATICALLY RUN DEFAULT!
      keyboard chr( 13 )
   else
      ADEFAULT := 1
   endif

   if len( AOPTIONS ) > 1
      CHOICE := MVERIFY( MSG, ADEFAULT, AOPTIONS )
      if AOPTIONS[ choice ] == 'Retry'
         TIMES_CALLED := 0
         return ( .t. )
      elseif AOPTIONS[ choice ] == 'Default'
         TIMES_CALLED := 0
         return ( .f. )
      endif
   else
      POP_MSG( MSG )
   endif

   EXIT_MSG := { 'An unrecoverable system error has occurred', ;
                 '', ;
                 'The details have been saved in a file for you', ;
                 '', ;
                 'Please contact your nearest technical support at:', ;
                 'Mark DeVuyst Key Largo FL @ (305) 852-9900', ;
                 'Phil Barnett Orlando   FL @ (407) 884-5192', ;
                 'Neal Kelly   Antrim    NH @ (603) 588-2237', ;
                 '', ;
                 'You must restart the program.' }

endif

POP_MSG( EXIT_MSG )
close all
myshowtime()
ALLKEY( 1 )
setcursor( 1 )
cls()
errorlevel( 1 )
quit

return NIL

*+
*+
*+    Static Function ERRORMESSAGE()
*+
*+    Called from ( error52.prg  )   2 - static function deferror()
*+                                   1 - static function errortxt()
*+
*+
*+
static func ERRORMESSAGE( e )

local CMESSAGE

// START error message
CMESSAGE := if( e:SEVERITY > ES_WARNING, "Error ", "Warning " )

// add SUBSYSTEM NAME if AVAILABLE
if ( valtype( e:SUBSYSTEM ) == "C" )
   CMESSAGE += e:SUBSYSTEM()
else
   CMESSAGE += "???"
endif

// add SUBSYSTEM's error code if available
if ( valtype( e:SUBCODE ) == "N" )
   CMESSAGE += ( "/" + NTRIM( e:SUBCODE ) )
else
   CMESSAGE += "/???"
endif

// add error DESCRIPTION if AVAILABLE
if ( valtype( e:DESCRIPTION ) == "C" )
   CMESSAGE += ( "  " + e:DESCRIPTION )
endif

// add EITHER FILENAME or OPERATION
if ( !empty( e:FILENAME ) )
   CMESSAGE += ( ": " + e:FILENAME )
elseif ( !empty( e:OPERATION ) )
   CMESSAGE += ( ": " + e:OPERATION )
endif

return ( CMESSAGE )

*+
*+
*+    Static Function DOSERRTEXT()
*+
*+    Called from ( error52.prg  )   1 - static function deferror()
*+                                   1 - static function errortxt()
*+
*+
*+
static function DOSERRTEXT( n )

local RETVAL

local OLDAREA := select()

if file( 'DOS_ERR.DBF' )
   use DOS_ERR NEW
   if !file( 'DOS_ERR' + myordbagext() )
      index on DOS_ERR->ERR_NO to DOS_ERR
   else
      set index to DOS_ERR
   endif
   if dbseek( n )
      RETVAL := DOS_ERR->ERR_TXT
   else
      RETVAL := 'Undefined or Reserved Dos Error #' + alltrim( str( n ) )
   endif
   close
   select( OLDAREA )
else
   RETVAL := 'DOS Error File DOS_ERR.DBF is missing.'
endif

return RETVAL

*+
*+
*+    Static Function ERR_OPEN_LIST()
*+
*+    Called from ( error52.prg  )   1 - static function deferror()
*+
*+
*+
static function ERR_OPEN_LIST

local INAREA := select()
local LNE    := replicate( chr( 205 ), 77 )
local TXT    := ''
local x
local INDX
local HNDLS  := 0

for x := 1 to 250
   dbselectarea( x )
   if !empty( alias() )
      TXT += iif( x == INAREA, "", " " ) + "    Alias = " + alias() + CRLF + CRLF
      TXT += '      Work area ' + ltrim( str( x ) ) + CRLF
      TXT += '  Record Number ' + ltrim( str( recno() ) ) + CRLF
      TXT += '    Field Count ' + ltrim( str( fcount() ) ) + CRLF
      TXT += '    Record Size ' + ltrim( str( recsize() ) ) + CRLF
      TXT += '   Record Count ' + ltrim( str( lastrec() ) ) + CRLF
      TXT += '      File Size ' + ltrim( str( DBFDSKSIZE() ) ) + CRLF
      TXT += '   Last Updated ' + FULLDATE( lupdate() ) + CRLF
      TXT += '    Driver Type ' + dbsetdriver() + CRLF
      if !empty( dbrelation() )
         TXT += '      Relations ' + dbrelation() + CRLF
      endif
      if !empty( dbfilter() )
         TXT += '         Filter ' + dbfilter() + CRLF
      endif
      if bof()
         TXT += '            BOF ' + STRINGIFY( bof() ) + CRLF
      endif
      if eof()
         TXT += '            EOF ' + STRINGIFY( eof() ) + CRLF
      endif
      if found()
         TXT += '          FOUND ' + STRINGIFY( found() ) + CRLF
      endif
      if deleted()
         TXT += '        Deleted ' + STRINGIFY( deleted() ) + CRLF
      endif
      if DBFSIZE() <> DBFDSKSIZE()
         TXT += '  ** Appended data has not yet been commited. **' + CRLF
      endif

      TXT  += CRLF
      INDX := 1
      HNDLS ++

#ifdef AXS
      if sx_keysincluded() > 0
         HNDLS ++
      endif
#else
      if sx_keycount() > 0
         HNDLS ++
      endif
#endif

      do while .t.
         if empty( indexkey( INDX ) )
            if INDX == 1
               TXT += "No indexes in use" + CRLF
            endif
            exit
         else
            TXT += iif( indexord() == INDX, '', ' ' ) + "   Key " + str( INDX, 2 ) + " = " + pad( ordbagname( INDX ), 15 ) + "  " + indexkey( INDX ) + CRLF
         endif
         INDX ++
      enddo
      TXT += LNE + CRLF
   endif
next

if HNDLS == 0
   TXT += "No Files Were Open." + CRLF + CRLF
else
   TXT += "Known Handles used = " + str( HNDLS, 3 ) + CRLF + CRLF
endif

select( INAREA )

return TXT

*+
*+
*+    Static Function SEP_LINE()
*+
*+    Called from ( error52.prg  )   7 - static function deferror()
*+                                   1 - static function systemtxt()
*+
*+
*+
static function SEP_LINE( header )

local FILLERLEN := 77 - len( header )
local ONESIDE   := PRB_INT( FILLERLEN / 2 )

return replicate( chr( 254 ), ONESIDE ) + ' ' + alltrim( header ) + ' ' + replicate( chr( 254 ), FILLERLEN - ONESIDE ) + CRLF + CRLF

*+
*+
*+    Static Function SYSTEMTXT()
*+
*+    Called from ( error52.prg  )   1 - static function deferror()
*+
*+
*+
static function SYSTEMTXT()

local TXT       := ''
local CPU       := ''
local FPU       := ''
local NCPUTYPE
local Drive
local x
local SIZEARRY
local NSTATUS
local cThisLine

TXT += '            DOS Version   ' + os() + CRLF
TXT += '        Clipper Version   ' + version() + CRLF
TXT += '  Clipper Tools Version   ' + TOOLVER() + CRLF
// TXT += '     SilverClip Version   ' + alltrim(str(SWASYNCVER()))+'.'+alltrim(str(SWASYNCREV())) + CRLF
TXT += '        Blinker Version   ' + ltrim( str( BLIVERNUM() / 100, 5, 2 ) ) + CRLF
#ifdef AXS
TXT += '            AXS Version   ' + ax_VERSION( 2 ) + CRLF
#else
TXT += '          COMIX Version   ' + sx_VERSION( 2 ) + CRLF
#endif
TXT += CRLF

if file( 'CPUTYPE.EXE' )

   swpruncmd( 'CPUTYPE > CPUTYPE.TXT' )

   bopen( 'CPUTYPE.TXT' )

   do while !beof()
      cThisLine := bReadLine()
      do case
      case left( cThisLine, 3 ) == 'CPU'
         CPU := cThisLine
      case left( cThisLIne, 3 ) == 'FPU'
         FPU := cThisLine
      endcase
   enddo

   bclose()

   TXT += '               ' + CPU + CRLF
   TXT += '               ' + FPU + CRLF

endif

TXT += '              Bios Date   ' + FULLDATE( BIOSDATE() ) + CRLF
TXT += CRLF
if !empty( DOSPARAM() )
   TXT += '           Command Line   ' + DOSPARAM() + CRLF
endif
TXT += '           Program Name   ' + EXENAME() + CRLF
TXT += '      Current Directory   ' + DISKNAME() + ':' + DIRNAME() + CRLF + CRLF

TXT += '   Maximum File Handles   ' + ltrim( str( FILESMAX() ) ) + CRLF
TXT += ' Available File Handles   ' + ltrim( str( FILESFREE() ) ) + CRLF
TXT += '  Available Stack Space   ' + ltrim( str( STACKFREE() ) ) + CRLF
TXT += 'Available String Memory   ' + ltrim( str( memory( 0 ) ) ) + CRLF + CRLF

TXT += '          Video adaptor   '
do case
case ISCGA( .t. )
   TXT += 'CGA'
case ISEGA( .t. )
   TXT += 'EGA'
case ISHERCULES( .t. )
   TXT += 'Hercules'
case ISMCGA( .t. )
   TXT += 'MCGA'
case ISMONO( .t. )
   TXT += 'Monochrome'
case ISPGA( .t. )
   TXT += 'PGA'
case ISVGA()
   TXT += 'VGA'
otherwise
   TXT += 'Unknown'
endcase

TXT += CRLF + CRLF

TXT += 'Printer Ports available' + str( NUMPRINTER(), 4 ) + CRLF

for x := 1 to 3
   NSTATUS := PRINTSTAT( x )
   if !PRINTREADY( x )
      if NSTATUS == 2
         TXT += space( 18 ) + 'LPT' + str( x, 1 ) + ':   No Port' + CRLF
      else
         TXT += space( 18 ) + 'LPT' + str( x, 1 ) + ':   Printer NOT ready' + CRLF
      endif
   endif
   if ISBIT( NSTATUS, 1 )
      TXT += space( 18 ) + 'LPT' + str( x, 1 ) + ':   Time Out Error' + CRLF
   endif
   if ISBIT( NSTATUS, 4 )
      TXT += space( 18 ) + 'LPT' + str( x, 1 ) + ':   Transmission Error' + CRLF
   endif
   if ISBIT( NSTATUS, 5 )
      TXT += space( 18 ) + 'LPT' + str( x, 1 ) + ':   Printer Online' + CRLF
   endif
   if ISBIT( NSTATUS, 6 )
      TXT += space( 18 ) + 'LPT' + str( x, 1 ) + ':   Out of Paper' + CRLF
   endif
   if ISBIT( NSTATUS, 7 )
      TXT += space( 18 ) + 'LPT' + str( x, 1 ) + ':   Printer Acknowledged' + CRLF
   endif
   if ISBIT( NSTATUS, 8 )
      TXT += space( 18 ) + 'LPT' + str( x, 1 ) + ':   Printer Not Available' + CRLF
   endif
next

TXT += CRLF

if COM_SETIO( 1, '3F8' )
   TXT += space( 18 ) + 'COM1:   Installed' + CRLF
else
   TXT += space( 18 ) + 'COM1:   No Port' + CRLF
endif
if COM_SETIO( 1, '2F8' )
   TXT += space( 18 ) + 'COM2:   Installed' + CRLF
else
   TXT += space( 18 ) + 'COM2:   No Port' + CRLF
endif
if COM_SETIO( 1, '3E8' )
   TXT += space( 18 ) + 'COM3:   Installed' + CRLF
else
   TXT += space( 18 ) + 'COM3:   No Port' + CRLF
endif
if COM_SETIO( 1, '2E8' )
   TXT += space( 18 ) + 'COM4:   Installed' + CRLF
else
   TXT += space( 18 ) + 'COM4:   No Port' + CRLF
endif

TXT += CRLF

SIZEARRY := {}
for x := 67 to 90
   Drive := chr( x )
   if !empty( DISKREADY( Drive ) )
      if ascan( SIZEARRY, DISKFREE( Drive ) ) == 0
         aadd( SIZEARRY, DISKFREE( Drive ) )
         TXT += '          Disk Space ' + Drive + ': ' + iif( DISKNAME() == Drive, '', ' ' ) + ' ' + transform( DISKFREE( Drive ), '999,999,999,999' ) + CRLF
      endif
   endif
next
TXT += CRLF
TXT += SEP_LINE( 'DOS Environment' ) + ENVPARAM() + CRLF + CRLF

return TXT

*+
*+
*+    Static Function ERRORTXT()
*+
*+    Called from ( error52.prg  )   1 - static function deferror()
*+
*+
*+
static function ERRORTXT( e )

local TXT      := ''
local x
local SEVERITY

if ( !empty( e:OSCODE ) )
   TXT += " (DOS Error " + NTRIM( e:OSCODE ) + ")    " + DOSERRTEXT( e:OSCODE ) + CRLF + CRLF
else
   TXT += ERRORMESSAGE( e ) + CRLF + CRLF
endif

if isarray( e:ARGS )
   TXT += 'Argument Stack:' + CRLF + CRLF
   for x := 1 to len( e:ARGS )
      TXT += space( 10 ) + 'Argument  #' + ltrim( str( x, 2 ) ) + '   ' + ltrim( STRINGIFY( e:ARGS[ X ] ) ) + CRLF
   next
   TXT += CRLF
endif

TXT += '     CanDefault   ' + STRINGIFY( e:CANDEFAULT ) + CRLF
TXT += '       CanRetry   ' + STRINGIFY( e:CANRETRY ) + CRLF
TXT += '  CanSubstitute   ' + STRINGIFY( e:CANSUBSTITUTE ) + CRLF
TXT += '          Cargo   ' + STRINGIFY( e:CARGO ) + CRLF
TXT += '    Description   ' + STRINGIFY( e:DESCRIPTION ) + CRLF
TXT += '       Filename   ' + STRINGIFY( e:FILENAME ) + CRLF
TXT += '        GenCode   ' + ltrim( STRINGIFY( e:GENCODE ) ) + CRLF
TXT += '      Operation   ' + STRINGIFY( e:OPERATION ) + CRLF

if e:OSCODE == 0
   TXT += '         OSCode   ' + 'Error did not originate from Operating System' + CRLF
else
   TXT += '         OSCode   ' + NTRIM( e:OSCODE ) + CRLF
endif

do case
case e:SEVERITY == 0
   SEVERITY := "Who Cares"
case e:SEVERITY == 1
   SEVERITY := 'Warning'
case e:SEVERITY == 2
   SEVERITY := "Error"
case e:SEVERITY == 3
   SEVERITY := "Catastrophic"
otherwise
   SEVERITY := 'Unknown'
endcase

TXT += '       Severity   ' + SEVERITY + CRLF
TXT += '      SubSystem   ' + STRINGIFY( e:SUBSYSTEM ) + CRLF
TXT += '        SubCode   ' + ltrim( STRINGIFY( e:SUBCODE ) ) + CRLF

if e:TRIES == 0
   TXT += '          Tries   ' + 'No Retries' + CRLF
else
   TXT += '          Tries   ' + NTRIM( e:TRIES ) + CRLF
endif

return TXT

*+
*+
*+    Static Function SCANCONV()
*+
*+    Called from ( error52.prg  )   1 - static function deferror()
*+
*+
*+
static function SCANCONV( SCANCODES )

local STRLEN     := len( SCANCODES )
local OUTSTRING  := ''
local PARSE_OUT  := ''
local x
local CONVERTED
local PAIR
local WORKSTRING
local M1
local M2
local INAREA     := select()

if file( 'SCANCODE.DBF' )

   POP_MSG( 'One moment while I save the latest keystrokes', .f. )

   use Scancode NEW
   if !file( 'SCANCODE' + myordbagext() )
      index on SCANCODE->SCANCODE to Scancode
   else
      set index to Scancode
   endif

   for x := 1 to STRLEN step 2
      PAIR := substr( SCANCODES, x, 2 )
      if dbseek( PAIR )
         CONVERTED := alltrim( SCANCODE->TOKEN )
      else
         CONVERTED := '<' + PAIR + '|' + ltrim( str( asc( PAIR ) ) ) + '|' + ltrim( str( asc( right( PAIR, 1 ) ) ) ) + '>'
      endif
      OUTSTRING += CONVERTED
   next

   dbclosearea()
   select( INAREA )

   do while len( OUTSTRING ) > 0
      WORKSTRING := left( OUTSTRING, 76 )
      M1         := rat( '>', WORKSTRING )
      M2         := rat( '<', WORKSTRING )
      do case
      case M2 > M1
         PARSE_OUT += left( OUTSTRING, M2 - 1 ) + CRLF
         OUTSTRING := substr( OUTSTRING, M2 )
      otherwise
         PARSE_OUT += WORKSTRING + CRLF
         OUTSTRING := substr( OUTSTRING, 77 )
      endcase
   enddo

   POP_MSGSCR()
else
   PARSE_OUT := 'Scan Code Table SCANCODE.DBF is missing' + CRLF
endif

return PARSE_OUT

*+ EOF: ERROR52.PRG
