*+
*+
*+    Source Module => D:\SRC\NGSRCHTM\NGSRCHTM.PRG
*+
*+    Copyright (C) 1997, Phil Barnett. All Rights Reserved Worldwide.
*+
*+    Functions: Procedure ngsrchtm()
*+               Function BoldIt()
*+               Function highstrip()
*+               Function htmlwrite()
*+
*+    Reformatted by Click! 2.02 on Jan-31-1999 at  9:24 pm
*+
*+

#include 'common.ch'

*+
*+
*+    Procedure ngsrchtm()
*+
*+
*+
procedure ngsrchtm( cFileName )

local handle
local crlf      := chr( 13 ) + chr( 10 )
local oBuff1
local oBuff2
local cThisLine := ''
local cSubLine  := ''
local x
local y
local cDesc
local cFile
local TrimLine
local nFile
local cName     := '!Name: not found.'
local aPri      := {}
local aSec      := {}
local aCredits  := {}
local nCut
local cNextLine
local nSection  := 0
local nSections := 0
local nHtml     := 0
local cOutput

local cFullPath := if( file( 'NG2HTML.INI' ), 'NG2HTML', RootName( ft_origin() ) ) + '.INI'

local cDiskPrefix := ProfileString( cFullPath, 'DISK', 'PREFIX', 'NGCVT' )

local cPriBackGrd := ProfileString( cFullPath, 'COLORS', 'PRIBACKGROUND', '' )
local cPriMenu    := ProfileString( cFullPath, 'COLORS', 'PRIMENU', '' )
local cFontColor  := ProfileString( cFullPath, 'COLORS', 'FONTCOLOR', '' )
local cSecBackGrd := ProfileString( cFullPath, 'COLORS', 'SECBACKGROUND', '' )
local cSecMenu    := ProfileString( cFullPath, 'COLORS', 'SECMENU', '' )

local cCellPad    := ProfileString( cFullPath, 'CELL', 'CELLPADDING', '15' )
local cCellBorder := ProfileString( cFullPath, 'CELL', 'BORDER', '3' )

default cFileName to ''

if empty( cFileName )
   ?
   ? 'Usage: NGSRCHTM <NGLinkFileName> <enter>'
   ?
   quit
endif

if !file( cFileName )
   ?
   ? 'File, ' + cFileName + ' not found.'
   ?
   quit
endif

if empty( cDiskPrefix ) .or. len( cDiskPrefix ) > 6
   ?
   ? 'DISKPREFIX in NGSRCHTM.INI must contain 1-6 characters.'
   ?
   quit
endif

? 'Norton Guide Source to HTML Converter v1.2'

cDiskPrefix := lower( cDiskPrefix )

oBuff1 := binit( cFileName )

bopen( oBuff1 )     // open NG Link script

do while !beof( oBuff1 )                // scan throught the link file for references.

   cThisLine := breadline( oBuff1 )
   TrimLine  := upper( alltrim( cThisLine ) )

   do case
   case '!NAME:' $ TrimLine

      // Grab the Name of the NG

      nCut  := at( ':', cThisLine )
      cName := alltrim( substr( cThisLine, nCut + 1 ) )

   case '!CREDITS:' $ TrimLine

      // Grab the Credits of the NG

      for x := 1 to 5
         cNextLine := bnextline( oBuff1 )
         if left( ltrim( cNextLine ), 1 ) == '!'
            exit
         endif
         aadd( aCredits, bReadLine( oBuff1 ) )
      next

   case left( TrimLine, 6 ) == '!MENU:'

      // This is a menu header

      nSection ++

      aadd( aPri, { strzero( nSection, 2 ), ltrim( substr( cThisLine, 7 ) ) } )

   case '.NGO' $ TrimLine

      // This is the reference to the .NGO file.
      // we convert the .NGO name to .DOC to find the NG object source

      nFile := numtoken( cThisLine, ' ' )
      cFile := rootname( token( cThisLine, ' ', nFile ) )
      cDesc := ''
      for y := 1 to nFile - 1
         cDesc += token( cThisLine, ' ', y ) + ' '
      next
      cDesc := trim( cDesc )
      aadd( aPri, { strzero( nSection, 2 ), cFile + '.DOC', cDesc, cDiskPrefix + strzero( ++ nHtml, 2 ) } )

   endcase

enddo

bclose( oBuff1 )

// Main page is created here

handle := fcreate( cDiskPrefix + '00.htm', 0 )

htmlwrite( handle, '<HTML>' + crlf )
htmlwrite( handle, '<HEAD><TITLE>' + cName + '</TITLE></HEAD>' + crlf )

? cName

htmlwrite( handle, '<BODY ' + cPriBackGrd + '>' + crlf + crlf )

htmlwrite( handle, '<CENTER><H1><I>' + cName + '</I></H1>' + crlf )

htmlwrite( handle, crlf + '<P>' + crlf + crlf )

if len( aCredits ) > 0
   htmlwrite( handle, '<PRE><B>' )
   for x := 1 to len( aCredits )
      cOutput := alltrim( highstrip( aCredits[ x ] ) )
      if !empty( cOutput )
         htmlwrite( handle, cOutput + crlf )
      endif
   next
   htmlwrite( handle, '</B></PRE>' + crlf )
endif

htmlwrite( handle, crlf + '<P>' + crlf + crlf )
htmlwrite( handle, '<TABLE ' + cCellBorder + ' ' + cCellPad + ' ' + cPriMenu + '><TR><TH>' + crlf )

for x := 1 to len( aPri )
   do case
   case len( aPri[ x ] ) == 2
      if x > 1
         htmlwrite( handle, '</TH></TR></TABLE>' + crlf )
         htmlwrite( handle, crlf + '<P>' + crlf + crlf )
         htmlwrite( handle, '<TABLE ' + cCellBorder + ' ' + cCellPad + ' ' + cPriMenu + '><TR><TH>' + crlf )
      endif
      htmlwrite( handle, '<H2><B><I>' + alltrim( HIGHSTRIP( aPri[ x, 2 ] ) ) + ':</I></B></H2>' + crlf )
      htmlwrite( handle, '</TH><TH>' + crlf )
   case len( aPri[ x ] ) == 4
      htmlwrite( handle, '   <A HREF="' + aPri[ x, 4 ] + '.htm' + '">' + aPri[ x, 3 ] + '</A><BR>' + crlf )
   endcase
next

htmlwrite( handle, '</TH></TR></TABLE>' + crlf )

htmlwrite( handle, crlf + '</CENTER></BODY></HTML>' + crlf )

fclose( handle )

// Now, create the sub pages

for x := 1 to len( aPri )

   if len( aPri[ x ] ) == 4

      handle := fcreate( aPri[ x, 4 ] + '.htm', 0 )

      htmlwrite( handle, '<HTML>' + crlf )
      htmlwrite( handle, '<HEAD><TITLE>' + aPri[ x, 3 ] + '</TITLE></HEAD>' + crlf )

      ? aPri[ x, 3 ]

      htmlwrite( handle, '<BODY ' + cSecBackGrd + '>' + crlf )
      htmlwrite( handle, '<P>' + crlf )
      htmlwrite( handle, '<CENTER><H1><I>' + cName + '</I></H1></CENTER>' + crlf )

      oBuff2 := binit( aPri[ x, 2 ] )

      aSec := {}

      if bopen( oBuff2 )

         do while !bEof( oBuff2 )

            cSubLine := breadline( oBuff2 )

            if '!SHORT:' $ upper( left( cSubLine, 7 ) )
               aadd( aSec, alltrim( highstrip( substr( cSubLine, 8 ) ) ) )
            endif

         enddo

         bclose( oBuff2 )

      endif

      htmlwrite( handle, '<CENTER><TABLE ' + cCellBorder + ' ' + cCellPad + ' ' + cSecMenu + '><TR><TH>' + crlf )

      htmlwrite( handle, '<H2><B><I>' + aPri[ x, 3 ] + ':</I></B></H2>' + crlf )
      htmlwrite( handle, '</TH><TH>' + crlf )

      for y := 1 to len( aSEC )
         htmlwrite( handle, '   <A HREF="' + aPri[ x, 4 ] + '.htm#' + strzero( y, 2 ) + '">' + aSec[ y ] + '</A><BR>' + crlf )
      next

      htmlwrite( handle, '</TH></TR></TABLE></CENTER>' + crlf )

      htmlwrite( handle, '<P><PRE>' + crlf )

      oBuff2 := binit( aPri[ x, 2 ] )

      nSections := 0

      if bopen( oBuff2 )

         do while !bEof( oBuff2 )

            cSubLine := breadline( oBuff2 )

            if '!SHORT:' $ upper( left( cSubLine, 7 ) )
               nSections ++
               htmlwrite( handle, '<A NAME="' + strzero( nSections, 2 ) + '">' )
               htmlwrite( handle, '<BR><P><H3><I>' + alltrim( highstrip( substr( cSubLine, 8 ) ) ) + '</I></H3></A>' + crlf )
            else
               if empty( cSubLine )
                  htmlwrite( Handle, crlf )
               else
                  htmlwrite( handle, HIGHSTRIP( BoldIt( cSubLine ) ) + crlf )
               endif
            endif

         enddo

         bclose( oBuff2 )

      endif

      fclose( handle )

   endif

next

htmlwrite( handle, '</PRE></BODY></HTML>' + crlf )

fclose( handle )

return

*+
*+
*+    Function BoldIt()
*+
*+    Called from ( ngsrchtm.prg )   1 - procedure ngsrchtm()
*+
*+
*+
function BoldIt( cText )

local nCounter := 0
local x
local nCount

cText  := strtran( cText, '^r', '^R' )
nCount := numfound( '^R', upper( cText ) )

if nCount > 0
   do while '^R' $ cText
      if ++ nCounter % 2 == 0
         x     := at( '^R', cText )
         cText := stuff( cText, x, 2, '</B>' )
      else
         x     := at( '^R', cText )
         cText := stuff( cText, x, 2, '<B>' )
      endif
   enddo
   if nCounter % 2 == 1
      cText += '</B>'
   endif
endif

cText    := strtran( cText, '^b', '^B' )
nCount   := numfound( '^B', upper( cText ) )
nCounter := 0

if nCount > 0
   do while '^B' $ cText
      if ++ nCounter % 2 == 1
         x     := at( '^B', cText )
         cText := stuff( cText, x, 2, '<B>' )
      else
         x     := at( '^B', cText )
         cText := stuff( cText, x, 2, '</B>' )
      endif
   enddo
   if nCounter % 2 == 1
      cText += '</B>'
   endif
endif

return cText

*+
*+
*+    Function highstrip()
*+
*+    Called from ( ngsrchtm.prg )   5 - procedure ngsrchtm()
*+
*+
*+
function highstrip( cText )

local cOut      := ''
local x
local nTextLen  := len( cText )
local nThisChar

for x := 1 to nTextLen
   nThisChar := asc( substr( cText, x, 1 ) )
   do case
   case nThisChar > 175 .and. nThisChar < 224
      cOut += '*'
   case nThisChar < 128
      cOut += substr( cText, x, 1 )
   endcase
next

return cOut

*+
*+
*+    Function htmlwrite()
*+
*+    Called from ( ngsrchtm.prg )  34 - procedure ngsrchtm()
*+
*+
*+
function htmlwrite( nHandle, cText )

/*
This section checks the content of the output.

If a http:/, ftp:/, mailto:/ or news:/ link is found, it is encapsulated
with a live link.

If a < or > is found to not be surrounding  a HTML command, it is fixed
so it will not disappear
*/

local cUpper  := upper( cText )
local cOutput := ''
local aHtml   := { '<BODY', '</BODY>', ;
                 '<HTML', '</HTML>', ;
                 '<HEAD', '</HEAD>', ;
                 '<FRAME', '</FRAME>', ;
                 '<TITLE>', '</TITLE>', ;
                 '<TABLE', '</TABLE>', ;
                 '<PRE>', '</PRE>', ;
                 '<CODE>', '</CODE>', ;
                 '<CENTER>', '</CENTER>', ;
                 '<A', 'A>', ;
                 '<H1>', '</H1>', ;
                 '<H2>', '</H2>', ;
                 '<H3>', '</H3>', ;
                 '<H4>', '</H4>', ;
                 '<TH>', '</TH>', ;
                 '<TR>', '</TR>', ;
                 '<BR>', '</BR>', ;
                 '<P>', '</P>', ;
                 '<B>', '</B>', ;
                 '<I>', '</I>' }
local nHtml      := len( aHtml )
local lHtml      := .f.
local x
local y
local cUrl
local nChars
local lFoundEnd
local lFoundCRLF
local lFoundGT
local CRLF       := chr( 13 ) + chr( 10 )
local cThisChar

if 'HTTP:/' $ cUpper .or. ;
           'FTP:/' $ cUpper .or. ;
           'NEWS:/' $ cUpper .or. ;
           'MAILTO:/' $ cUpper
   cOutput := ''
   nChars  := len( cUpper )
   for x := 1 to nChars
      if substr( cUpper, x, 6 ) == 'HTTP:/' .or. ;
                 substr( cUpper, x, 5 ) == 'FTP:/' .or. ;
                 substr( cUpper, x, 6 ) == 'NEWS:/' .or. ;
                 substr( cUpper, x, 8 ) == 'MAILTO:/'

         for y := x to nChars

            cThisChar := substr( cText, y, 1 )

            lFoundEnd  := cThisChar == ' '
            lFoundGT   := cThisChar == '<'
            lFoundCRLF := cThisChar $ CRLF

            if lFoundEnd .or. lFoundCRLF .or. lFoundGT
               cUrl := substr( cText, x, y - x )
               ? cUrl
               ?
               cOutput += '<A HREF="' + cUrl + '" >' + cUrl + '</A>' + iif( lFoundCRLF, CRLF, cThisChar )
               ? cOutput
               ?
               if lFoundCRLF
                  x := y + 1
               else
                  x := y
               endif
               exit
            endif
         next
      else
         cOutput += substr( cText, x, 1 )
      endif
   next
else
   cOutput := cText
endif

for x := 1 to nHtml
   if aHtml[ x ] $ cUpper
      lHtml := .t.
      exit
   endif
next

if !lHtml
   // Fix the output to show the < and > characters.
   cOutput := strtran( cOutput, '<', '&#60' )
   cOutput := strtran( cOutput, '>', '&#62' )
endif

return fwrite( nHandle, cOutput )

*+ EOF: NGSRCHTM.PRG
